// SWIG Interface file for Python-Ygl. 
// Prabhu Ramachandran <prabhu_r@users.sf.net>

%module ygl
%{
#include "X11/Ygl.h"
#include <unistd.h>
#include "mouse_zoom.h"
%}

%include "X11/Ygltypes.h"
extern unsigned int sleep(unsigned int );

// -----------------------------------------------------------------
// Handle the varargs usefully.  addtopup uses variable args.  Using
// this makes the function usable.
%varargs(Int32 v) addtopup;

// -----------------------------------------------------------------
// Create nice pointer/array representations for various types.
%include "cpointer.i"
%include "carrays.i"

%pointer_class(Int16, Int16_p);
%pointer_class(Int32, Int32_p);
%pointer_class(Coord, Coord_p);
%pointer_class(Screencoord, Screencoord_p);
%pointer_class(Uint8, Uint8_p);

// -----------------------------------------------------------------
// Now include Ygl etc.
%include "Ygl.h"

// Mouse based zoom feature.
%include mouse_zoom.h

%inline %{
// Below I salvage menus by providing a hack to get menu's to work
Int32 dummy(Int32 Int32_menu) 
{
    return Int32_menu;
}

void add2pup(Int32 Int32_menu, Char8 *str)
{
    addtopup(Int32_menu, str, (Int32)dummy);
}
%}

